blob: cafbe1ffbd4b6d93427b7d55f0c1cc20bb1cfe28 [file] [log] [blame]
Ales Komareka75a89c2014-01-19 17:50:15 +01001#! /bin/sh
2### BEGIN INIT INFO
3# Provides: statsd
4# Required-Start: $network $local_fs
5# Required-Stop:
6# Default-Start: 2 3 4 5
7# Default-Stop: 0 1 6
8### END INIT INFO
9
10# Do NOT "set -e"
11
12PATH=$PATH:/usr/local/bin:/usr/bin:/bin
13NODE_BIN=$(which nodejs||which node)
14
15if [ ! -x "$NODE_BIN" ]; then
16 echo "Can't find executable nodejs or node in PATH=$PATH"
17 exit 1
18fi
19
20# PATH should only include /usr/* if it runs after the mountnfs.sh script
21PATH=/sbin:/usr/sbin:/bin:/usr/bin
22DESC="StatsD"
23NAME=statsd
24DAEMON=$NODE_BIN
Ales Komarekceefc482014-04-10 10:13:23 +020025DAEMON_ARGS="/srv/statsd/statsd/stats.js /etc/statsd/localConfig.js 2>&1 >> /var/log/statsd/statsd.log "
Ales Komareka75a89c2014-01-19 17:50:15 +010026PIDFILE=/var/run/$NAME.pid
27SCRIPTNAME=/etc/init.d/$NAME
28CHDIR="/srv/statsd"
29
30# Exit if the package is not installed
31# [ -x "$DAEMON" ] || exit 0
32
33# Read configuration variable file if it is present
34[ -r /etc/default/$NAME ] && . /etc/default/$NAME
35
36# Load the VERBOSE setting and other rcS variables
37. /lib/init/vars.sh
38
39# Define LSB log_* functions.
40# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
41. /lib/lsb/init-functions
42
43#
44# Function that starts the daemon/service
45#
46do_start()
47{
48# Return
49# 0 if daemon has been started
50# 1 if daemon was already running
51# 2 if daemon could not be started
52start-stop-daemon --start --quiet -m --pidfile $PIDFILE --startas $DAEMON --background --test > /dev/null \
53|| return 1
54start-stop-daemon --start --quiet -m --pidfile $PIDFILE --startas $DAEMON --background --chdir $CHDIR -- \
55$DAEMON_ARGS > /dev/null 2> /var/log/$NAME-stderr.log \
56|| return 2
57# Add code here, if necessary, that waits for the process to be ready
58# to handle requests from services started subsequently which depend
59# on this one. As a last resort, sleep for some time.
60}
61
62#
63# Function that stops the daemon/service
64#
65do_stop()
66{
67# Return
68# 0 if daemon has been stopped
69# 1 if daemon was already stopped
70# 2 if daemon could not be stopped
71# other if a failure occurred
72start-stop-daemon --stop --quiet --retry=0/0/KILL/5 --pidfile $PIDFILE
73RETVAL="$?"
74[ "$RETVAL" = 2 ] && return 2
75# Wait for children to finish too if this is a daemon that forks
76# and if the daemon is only ever run from this initscript.
77# If the above conditions are not satisfied then add some other code
78# that waits for the process to drop all resources that could be
79# needed by services started subsequently. A last resort is to
80# sleep for some time.
81start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
82[ "$?" = 2 ] && return 2
83# Many daemons don't delete their pidfiles when they exit.
84rm -f $PIDFILE
85return "$RETVAL"
86}
87
88#
89# Function that sends a SIGHUP to the daemon/service
90#
91do_reload() {
92#
93# If the daemon can reload its configuration without
94# restarting (for example, when it is sent a SIGHUP),
95# then implement that here.
96#
97start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
98return 0
99}
100
101case "$1" in
102 start)
103[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
104do_start
105case "$?" in
1060|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
1072) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
108esac
109;;
110 stop)
111[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
112do_stop
113case "$?" in
1140|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
1152) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
116esac
117;;
118 #reload|force-reload)
119#
120# If do_reload() is not implemented then leave this commented out
121# and leave 'force-reload' as an alias for 'restart'.
122#
123#log_daemon_msg "Reloading $DESC" "$NAME"
124#do_reload
125#log_end_msg $?
126#;;
127 restart|force-reload)
128#
129# If the "reload" option is implemented then remove the
130# 'force-reload' alias
131#
132log_daemon_msg "Restarting $DESC" "$NAME"
133do_stop
134case "$?" in
1350|1)
136do_start
137case "$?" in
1380) log_end_msg 0 ;;
1391) log_end_msg 1 ;; # Old process is still running
140*) log_end_msg 1 ;; # Failed to start
141esac
142;;
143*)
144# Failed to stop
145log_end_msg 1
146;;
147esac
148;;
149 status)
150 status_of_proc $DAEMON "$NAME"
151 ;;
152 *)
153echo "Usage: $SCRIPTNAME {start|stop|restart|status|force-reload}" >&2
154exit 3
155;;
156esac
157
158: